
-- TYSM TYLUGE FOR THIS PARTICLE CODE!!!!!

particleangle = 0
E_MODEL_ROLLPARTICLE = smlua_model_util_get_id("rollparticle_geo")
local spawntimer = 0

local obj_mark_for_deletion = obj_mark_for_deletion

gStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gStateExtras[i] = {}
    local m = gMarioStates[i]
    local e = gStateExtras[i]

e.personalTimer = 0
end

bhv_rollparticle_init = function(obj)
  --- flip left-right script

  obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
obj.oOpacity = 255
obj.oFaceAnglePitch = 0
cur_obj_scale(1.2)
obj.oFaceAngleRoll = 0

obj.oFaceAngleYaw = (particleangle)

end

bhv_dashparticle_init = function(obj)
  --- flip left-right script

  obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
obj.oOpacity = 255
obj.oFaceAnglePitch = 0
cur_obj_scale(0.5)
obj.oFaceAngleRoll = 0

obj.oFaceAngleYaw = (particleangle)

end

---@param o Object
rollparticle_effect_loop = function(obj)

  obj.oOpacity = obj.oOpacity - 25
  --- animations
  if obj.oOpacity <= 0 then
    obj_mark_for_deletion(obj)
  end

end

id_bhvrollparticle = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, bhv_rollparticle_init, rollparticle_effect_loop)
id_bhvdashparticle = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, bhv_dashparticle_init, rollparticle_effect_loop)

function place_rollparticle(x,y,z)
	local rollparticle = spawn_sync_object(
		id_bhvrollparticle,
		E_MODEL_ROLLPARTICLE,
		x,y,z,
        
		function (obj)
			obj.oOpacity = 255
			obj.oFaceAnglePitch = 0
			obj.oFaceAngleYaw = 0
			obj.oFaceAngleRoll = 0
		end
	)
end

function place_dashparticle(x,y,z)
	local dashparticle = spawn_sync_object(
		id_bhvdashparticle,
		E_MODEL_WATER_RING,
		x,y,z,
        
		function (obj)
			obj.oOpacity = 255
			obj.oFaceAnglePitch = 0
			obj.oFaceAngleYaw = 0
			obj.oFaceAngleRoll = 0
		end
	)
end

function mario_update(m)
    if m.playerIndex == 0 then

        particleangle = m.marioObj.header.gfx.angle.y
        gPlayerSyncTable[m.playerIndex].modelId = E_MODEL_ROLLPARTICLE

      if m.action == ACT_KAPI_ROLL then
        spawntimer = spawntimer + 1
        if spawntimer >= 2 then
        place_rollparticle(m.pos.x, m.pos.y + 1, m.pos.z)
        spawntimer = 0
        end
      end
      
      if (m.action == ACT_KAPI_DASH or m.action == ACT_KAPI_WATER_TURBINE) and m.actionTimer < 16 then
        spawntimer = spawntimer + 1
        if spawntimer >= 4 then
        place_dashparticle(m.pos.x, m.pos.y, m.pos.z)
        spawntimer = 0
        end
      end
      
    end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)